//+------------------------------------------------------------------+
//|                                             OnlyPivot_filter.mq4 |
//|                                                     David Willis |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "David Willis"
#property link      ""


extern double  Lots = 0.1;  
extern int     Start_time = 0; // the Hour to start
extern int     endtradingtime=17;
extern int     slippage = 5;
extern int     MagicNumber = 123456;
extern int     filter=5;
extern int     MAMode=2;  //0=sma, 1=ema, 2=smma, 3=lwma
extern int     pricemode=6;  // 0=close, 1=open,2=high,3=low,4=median, 5=typical, 6=weighted 
extern int     enday=23;
extern int     endayfriday=19;

//profit targets
extern double      TP1 = 50;       //first profit target
extern double      TP2 = 110;      //second profit target
extern double      TP3 = 0;        //third profit target
extern double      TP4 = 0;
extern double      TP5 = 0;

//trail stop loss
extern double      SLinitial=75;   //initial stop loss
extern double      SL1 = -1;
extern double      SL2 = -50;
extern double      SL3 = 0;
extern double      SL4 = 0;
extern double      SL5 = 0;
extern double      SLA1 = 50;     //pips provit to move to first sl
extern double      SLA2 = 100;
extern double      SLA3 = 0; 
extern double      SLA4 = 0;
extern double      SLA5 = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  int numbertrades=trades();
  double sl,tp1,tp2,tp3,tp4,tp5;
   
   double daily = Open[openhour()];
   
   Comment("opentrades = ",opentrades());

// Take care of open trades
   modifystoploss();
   
   if(opentrades()>0)
     {
     
      //close at end of day
      if(endofday()>0) {closealltrades();} 
      
      //stop and reverse 
      if(tradedirection()==1)  //0=short trade 1=long trade...this is for long
        {
         if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < daily-filter*Point && Minute()==0 && iMA(Symbol(),0,2,0,MAMode,pricemode,2)>daily-filter*Point)
           {
            closealltrades();
            if(opentrades()>0) {return(0);}
            if (tradingtime()>0)
            {             
               sl=Bid+SLinitial*Point;
               tp1=Bid-TP1*Point;
               tp2=Bid-TP2*Point;
               tp3=Bid-TP3*Point;
               tp4=Bid-TP4*Point;
               tp5=Bid-TP5*Point;
               OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>3)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>4)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Red);}
             }
           }     
        }
        
      if(tradedirection()==0)  //Short trade
        {
         if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > daily+filter*Point && Minute()==0 && iMA(Symbol(),0,2,0,MAMode,pricemode,2) < daily+filter*Point)
           {
            closealltrades();
            if(opentrades()>0) {return(0);}
            if (tradingtime()>0)
            {
               sl=Ask-SLinitial*Point;
               tp1=Ask+TP1*Point;
               tp2=Ask+TP2*Point;
               tp3=Ask+TP3*Point;
               tp4=Ask+TP4*Point;
               tp5=Ask+TP5*Point;
               OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>3)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>4)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Blue);}
             }
           }
        }
      }
   // No open trades   
   if(tradingtime()>0 && opentrades()==0) 
     {
      //Start of day
      if(Hour()==Start_time+1 && Minute()==0)
        {
         if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > daily+filter*Point)
          {
               sl=Ask-SLinitial*Point;
               tp1=Ask+TP1*Point;
               tp2=Ask+TP2*Point;
               tp3=Ask+TP3*Point;
               tp4=Ask+TP4*Point;
               tp5=Ask+TP5*Point;
               OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>3)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>4)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Blue);}
          
          }
          
         if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < daily-filter*Point) 
          {
               sl=Bid+SLinitial*Point;
               tp1=Bid-TP1*Point;
               tp2=Bid-TP2*Point;
               tp3=Bid-TP3*Point;
               tp4=Bid-TP4*Point;
               tp5=Bid-TP5*Point;
               OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>3)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>4)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Red);}
          }
        }
        
      // 2wma cross 
      if (tradingtime()>0 && opentrades()==0)
        {
         if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) > daily+filter*Point && Minute()==0 && iMA(Symbol(),0,2,0,MAMode,pricemode,2) < daily+filter*Point)
          {
               sl=Ask-SLinitial*Point;
               tp1=Ask+TP1*Point;
               tp2=Ask+TP2*Point;
               tp3=Ask+TP3*Point;
               tp4=Ask+TP4*Point;
               tp5=Ask+TP5*Point;
               OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>3)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>4)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Blue);}
          }
          
         if(iMA(Symbol(),0,2,0,MAMode,pricemode,1) < daily-filter*Point && Minute()==0 && iMA(Symbol(),0,2,0,MAMode,pricemode,2)>daily-filter*Point)
          {
               sl=Bid+SLinitial*Point;
               tp1=Bid-TP1*Point;
               tp2=Bid-TP2*Point;
               tp3=Bid-TP3*Point;
               tp4=Bid-TP4*Point;
               tp5=Bid-TP5*Point;
               OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>3)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp4,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>4)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp5,"Only"+MagicNumber,MagicNumber,0,Red);}
          }
         
         
        
        }
     }
         
   return(0);
  }
//+------------------------------------------------------------------+


void modifystoploss()
{
  int cnt;
  double buyprice, currentsl,newsl=0;
  
  
  //find current buyprice and stop loss
  for(cnt=0;cnt<OrdersTotal();cnt++)   
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
      {
        buyprice=OrderOpenPrice();
        currentsl=OrderStopLoss();
      }
    }  
  
  
  //for long trades
  if(tradedirection()==1)
  {       
    if(SLA1 != 0 && Bid>= buyprice+SLA1*Point) {newsl=buyprice-SL1*Point;}
    if(SLA2 != 0 && Bid>= buyprice+SLA2*Point) {newsl=buyprice-SL2*Point;}
    if(SLA3 != 0 && Bid>= buyprice+SLA3*Point) {newsl=buyprice-SL3*Point;}
    if(SLA4 != 0 && Bid>= buyprice+SLA4*Point) {newsl=buyprice-SL4*Point;}
    if(SLA5 != 0 && Bid>= buyprice+SLA5*Point) {newsl=buyprice-SL5*Point;}
    
    if(newsl>currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
  else if(tradedirection()==0)
  {    
    if(SLA1 != 0 && Ask<= buyprice-SLA1*Point) {newsl=buyprice+SL1*Point;}
    if(SLA2 != 0 && Ask<= buyprice-SLA2*Point) {newsl=buyprice+SL2*Point;}
    if(SLA3 != 0 && Ask<= buyprice-SLA3*Point) {newsl=buyprice+SL3*Point;}
    if(SLA4 != 0 && Ask<= buyprice-SLA4*Point) {newsl=buyprice+SL4*Point;}
    if(SLA5 != 0 && Ask<= buyprice-SLA5*Point) {newsl=buyprice+SL5*Point;}
    
    if(newsl<currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
}


int opentrades()
{
  int trades=0;
  int cnt;
  
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);  
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) {trades ++;}
  }     
  return(trades);
}


int endofday()
{
  int dayend=0; 
  if(Hour()==enday) {dayend=1;}
  if(DayOfWeek()==5 && Hour()==endayfriday) {dayend=1;}
  return(dayend);
}

void closealltrades()
{
  int cnt;
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {		
	 	 if(OrderType() == 1) 	
	 	 {OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow);}
	 	 else {OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow);}
	 }
  }
}

 
int tradedirection()
{

  int cnt;
  int direction;
  
  for(cnt=OrdersTotal();cnt>=0;cnt--)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {				
	 	 if (OrderType() == 0) {direction=1;}
	 	 if (OrderType() == 1) {direction=0;}
	 	 cnt=-1;
	 }
  }
  return (direction);
}
 
 

int openhour()
{
  int hours;
  
  if(Hour()< Start_time) {hours=24-Start_time+Hour();}
  else {hours=Hour()-Start_time;}
  
  return(hours);
}
  
int trades()
{
  int trades=0;
  
  if(TP1>0){trades ++;}
  if(TP2>0){trades ++;}
  if(TP3>0){trades ++;}
  if(TP4>0){trades ++;}
  if(TP5>0){trades ++;}
  
  
  return(trades);
}
  
  
int tradingtime()
{

  int trading=0;
  
  if(Start_time<endtradingtime && Hour()<endtradingtime && Hour()>Start_time) {trading=1;}
  if(Start_time>endtradingtime)
  {
    if(Hour()>Start_time) {trading=1;}
    if(Hour()<endtradingtime){trading=1;}
  }
  return(trading);
}
  